/* Copyright 1995, Columbia University, all rights reserved.
 * Permission is granted to utilize and disseminate this code or
 *  document without charge, provided that (1) this copyright notice is 
 *  not removed, and (2) all changes made by other than members of the 
 *  MacroModel Development Group at Columbia University are, if further 
 *  disseminated, (a) noted as such; for example, by means of source-code 
 *  comment lines, and (b) communicated back to the author for possible 
 *  inclusion in subsequent versions. */

/****************************************************************************
 * $RCSfile: mmio.h,v $
 * $Revision: 1.10 $
 * $Date: 1998/02/06 05:31:23 $
 ***************************************************************************/
#ifndef __MMIO_H__
#define __MMIO_H__
#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include "mmio_def.h"

/************************************************************************/
/* Prototypes for public functions...: */

/*    ...File opening & closing: */
int mmio_open( int *ifile, char *fname, int mode );
int mmio_close( int ifile );
int mmio_cleanup( void );

/*    ...Error handling: */
void mmio_errfile( FILE *file );
char *mmio_return_code( int status );

/*    ...Moving around in input file: */
int mmio_goto_ct( int ifile, int ict_new );
int mmio_skip_ct( int ifile, int nct_skip );
int mmio_count_ct( int ifile, int *nct );

/*    ...Reading a CT: */
int mmio_get_ct( int ifile, int ct_type, int *natom, char *title );
int mmio_get_atom( int ifile, int *mmod_iatom, int *itype, int *nbond,
 int *bond_atom, int *bond_order, float *xyz, float *charge1, float *charge2,
 char *chain, int *color, int *resnum, char *resname1, char *resname4,
 char *pdbname );
int mmio_get_atomg( int ifile, int *mmod_iatom, int *itype, int *nbond,
 int *bond_atom, int *bond_order, float *xyz, float *charge1, float *charge2,
 char *chain, int *color, int *resnum, char *resname1, char *resname4,
 char *pdbname, char *growname );

/*    ...Writing a CT: */
int mmio_put_ct( int ifile, int ct_type, int natom, char *title );
int mmio_put_atom( int ifile, int mmod_iatom, int itype, int nbond,
 int *bond_atom, int *bond_order, float *xyz, float charge1, float charge2,
 char chain, int color, int resnum, char resname1, char *resname4,
 char *pdbname );
int mmio_put_atomg( int ifile, int mmod_iatom, int itype, int nbond,
 int *bond_atom, int *bond_order, float *xyz, float charge1, float charge2,
 char chain, int color, int resnum, char resname1, char *resname4,
 char *pdbname, char *growname );

/************************************************************************/

#ifdef __cplusplus
}
#endif
#endif /* ! __MMIO_H__ */
