/* Copyright 1995, Columbia University, all rights reserved.
 * Permission is granted to utilize and disseminate this code or
 *  document without charge, provided that (1) this copyright notice is 
 *  not removed, and (2) all changes made by other than members of the 
 *  MacroModel Development Group at Columbia University are, if further 
 *  disseminated, (a) noted as such; for example, by means of source-code 
 *  comment lines, and (b) communicated back to the author for possible 
 *  inclusion in subsequent versions. */

/****************************************************************************
 * $RCSfile: mmio_def.h,v $
 * $Revision: 1.3 $
 * $Date: 1996/01/24 16:53:45 $
 ***************************************************************************/
#ifdef __cplusplus
extern "C" {
#endif

/* maximum number of atoms connected to a given atom: */
#define MMIO_MAXBOND 6

/* length of string passed to/from library: */
#define MMIO_L_STRLEN 200
#define MMIO_S_STRLEN 4

/* after reading a CT, return one of these status values: */
#define MMIO_COMPRESSED 1
#define MMIO_FULL 3
#define MMIO_OK 4
#define MMIO_EOF 5
#define MMIO_DONE 6
#define MMIO_ERR 7
#define MMIO_BOF 8

/* file-opening modes: */
#define MMIO_READ 0
#define MMIO_WRITE 1
#define MMIO_APPEND 2
#define MMIO_UNUSED 3

/***************************************************************************/
#ifdef __cplusplus
}
#endif
