/* Copyright 1995, Columbia University, all rights reserved.
 * Permission is granted to utilize and disseminate this code or
 *  document without charge, provided that (1) this copyright notice is 
 *  not removed, and (2) all changes made by other than members of the 
 *  MacroModel Development Group at Columbia University are, if further 
 *  disseminated, (a) noted as such; for example, by means of source-code 
 *  comment lines, and (b) communicated back to the author for possible 
 *  inclusion in subsequent versions. */

/****************************************************************************
 * $RCSfile: mmioc.h,v $
 * $Revision: 1.11 $
 * $Date: 1998/02/06 05:31:23 $
 ***************************************************************************/

/* Prototypes for private functions;  these functions have a one-to-one
 *  correspondence to the functions available in the API: */

/*    ...File opening & closing: */
int _file_open( int *idataset, char *fname, int mode );
int _file_close( int idataset );

/*    ...Error handling: */
void _setc_errfile( FILE *file );	/* from C API */
void _setf_errfile( int unit );		/* from Fortran API */
void _error_mmio( char *fmt, ... );


char *_return_code( int status );

/*    ...Moving around in input file: */
int _goto_ct( int idataset, int ict_new );
int _skip_ct( int idataset, int nct_skip );
int _count_ct( int idataset, int *nct );

/*    ...Reading a CT: */
int _get_ct( int idataset, int ct_type, int *natom, char *title );
int _get_atom( int idataset, int *mmod_iatom, int *itype, int *nbond,
 int *bond_atom, int *bond_order, float *xyz, float *charge1, float *charge2,
 char *chain, int *color, int *resnum, char *resname1, char *resname4,
 char *pdbname, char *growname, int from_fortran );

/*    ...Writing a CT: */
int _put_ct( int idataset, int ct_type, int natom, char *title );
int _put_atom( int idataset, int mmod_iatom, int itype, int nbond,
 int *bond_atom, int *bond_order, float *xyz, float charge1, float charge2,
 char chain, int color, int resnum, char resname1, char *resname4,
 char *pdbname, char *growname );

/*    ...Misc: */
int _cleanup_mmio( void );
/****************************************************************************/
